'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _globby = require('globby');

var _globby2 = _interopRequireDefault(_globby);

var _imagemin = require('imagemin');

var _imagemin2 = _interopRequireDefault(_imagemin);

var _imageminJpegRecompress = require('imagemin-jpeg-recompress');

var _imageminJpegRecompress2 = _interopRequireDefault(_imageminJpegRecompress);

var _imageminJpegtran = require('imagemin-jpegtran');

var _imageminJpegtran2 = _interopRequireDefault(_imageminJpegtran);

var _imageminGifsicle = require('imagemin-gifsicle');

var _imageminGifsicle2 = _interopRequireDefault(_imageminGifsicle);

var _imageminOptipng = require('imagemin-optipng');

var _imageminOptipng2 = _interopRequireDefault(_imageminOptipng);

var _imageminSvgo = require('imagemin-svgo');

var _imageminSvgo2 = _interopRequireDefault(_imageminSvgo);

var _winston = require('winston');

var _winston2 = _interopRequireDefault(_winston);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ImageProcessor = function () {
  function ImageProcessor() {
    _classCallCheck(this, ImageProcessor);

    this.plugins = [(0, _imageminJpegRecompress2.default)(), (0, _imageminJpegtran2.default)(), (0, _imageminGifsicle2.default)(), (0, _imageminOptipng2.default)(), (0, _imageminSvgo2.default)()];
  }

  _createClass(ImageProcessor, [{
    key: 'run',
    value: function run(path) {
      var _this = this;

      var allFolders = _globby2.default.sync(path + '/**/'); // Trailing slash matches directories only

      var allFoldersPromises = allFolders.map(function (folder) {
        return (0, _imagemin2.default)([folder + '/*'], folder, { plugins: _this.plugins }).then(function (files) {
          _winston2.default.info('\n' + files.map(function (x) {
            return x.path;
          }).join('\n'));
        });
      });

      return Promise.all(allFoldersPromises);
    }
  }]);

  return ImageProcessor;
}();

exports.default = ImageProcessor;